#########################################################################################
# -*- coding: utf-8 -*-
#
# This file is part of the RCUSCC project
#
#
#
# Distributed under the terms of the APACHE license.
# See LICENSE.txt for more info.
#########################################################################################
"""Contain the tests for the RCU-SCC Device Server for LOFAR2.0."""

# Path
import sys
import os
path = os.path.join(os.path.dirname(__file__), os.pardir)
sys.path.insert(0, os.path.abspath(path))

# Imports
import pytest
from mock import MagicMock

from PyTango import DevState

# PROTECTED REGION ID(RCUSCC.test_additional_imports) ENABLED START #
# PROTECTED REGION END #    //  RCUSCC.test_additional_imports


# Device test case
@pytest.mark.usefixtures("tango_context", "initialize_device")
# PROTECTED REGION ID(RCUSCC.test_RCUSCC_decorators) ENABLED START #
# PROTECTED REGION END #    //  RCUSCC.test_RCUSCC_decorators
class TestRCUSCC(object):
    """Test case for packet generation."""

    properties = {
        'OPC_Server_Name': '',
        'OPC_Server_Port': '',
        'OPC_Time_Out': '',
        }

    @classmethod
    def mocking(cls):
        """Mock external libraries."""
        # Example : Mock numpy
        # cls.numpy = RCUSCC.numpy = MagicMock()
        # PROTECTED REGION ID(RCUSCC.test_mocking) ENABLED START #
        # PROTECTED REGION END #    //  RCUSCC.test_mocking

    def test_properties(self, tango_context):
        # Test the properties
        # PROTECTED REGION ID(RCUSCC.test_properties) ENABLED START #
        # PROTECTED REGION END #    //  RCUSCC.test_properties
        pass

    # PROTECTED REGION ID(RCUSCC.test_State_decorators) ENABLED START #
    # PROTECTED REGION END #    //  RCUSCC.test_State_decorators
    def test_State(self, tango_context):
        """Test for State"""
        # PROTECTED REGION ID(RCUSCC.test_State) ENABLED START #
        assert tango_context.device.State() == DevState.UNKNOWN
        # PROTECTED REGION END #    //  RCUSCC.test_State

    # PROTECTED REGION ID(RCUSCC.test_Status_decorators) ENABLED START #
    # PROTECTED REGION END #    //  RCUSCC.test_Status_decorators
    def test_Status(self, tango_context):
        """Test for Status"""
        # PROTECTED REGION ID(RCUSCC.test_Status) ENABLED START #
        assert tango_context.device.Status() == "The device is in UNKNOWN state."
        # PROTECTED REGION END #    //  RCUSCC.test_Status


    # PROTECTED REGION ID(RCUSCC.test_time_offset_rw_decorators) ENABLED START #
    # PROTECTED REGION END #    //  RCUSCC.test_time_offset_rw_decorators
    def test_time_offset_rw(self, tango_context):
        """Test for time_offset_rw"""
        # PROTECTED REGION ID(RCUSCC.test_time_offset_rw) ENABLED START #
        assert tango_context.device.time_offset_rw == 0
        # PROTECTED REGION END #    //  RCUSCC.test_time_offset_rw

    # PROTECTED REGION ID(RCUSCC.test_time_offset_r_decorators) ENABLED START #
    # PROTECTED REGION END #    //  RCUSCC.test_time_offset_r_decorators
    def test_time_offset_r(self, tango_context):
        """Test for time_offset_r"""
        # PROTECTED REGION ID(RCUSCC.test_time_offset_r) ENABLED START #
        assert tango_context.device.time_offset_r == 0
        # PROTECTED REGION END #    //  RCUSCC.test_time_offset_r


